#include <fstream>
#include <iostream>
#include <stdio.h>
#include <string>
#include "IMA_ADPCM.cpp"


 int main(int argc, char * argv[])
{
  unsigned long noHeader, WtHeader;
  string OrigFile, FileTemp, ApndPath;
  FILE *pcmFile, *pcmtemp;
  IMA_ADPCM DeCom;
  
  unsigned char rawPcm[16] = {//generic header for both mono & stereo (since we
  //convert stereo to mono)
  0x22, 0x56, 0x00, 0x00, 0x44, 0xAC, 0x00, 0x00, 0x02, 0x00, 0x10, 0x00, 0x64,
  0x61, 0x74, 0x61, 
   };
  
       /* use string dissection to append/build desired pathways */
   
         if(argv[1]>0)
          {
           FileTemp=argv[1];
           ApndPath=argv[1];
           OrigFile=argv[1];
           int keeppath = FileTemp.rfind("\\");
           FileTemp.erase(0,keeppath+1);
           int killname = FileTemp.rfind(".");
           FileTemp.erase(killname);
           
           int findpath = ApndPath.find_last_of("\\");
           ApndPath.erase(findpath+1);
           
           ApndPath+="Dec_";
           ApndPath+=FileTemp;
           ApndPath+=".wav";
           
           }
         else {
           std::cout<<"Drop ima/dvi adpcm, 22050 mono or 44100 stereo""\n"
           "wave file onto window. Press [Enter] to exit ";
           std::cin.get();
            return 0; //kill program if no wav file dropped
         }
           
           
   short PcmBlockSize;
   unsigned char ChkChannels;
   unsigned long WaveDataSize;
   int Pcm_Decode=0;
   unsigned long wvformat;
   short balign;

   pcmtemp=fopen(OrigFile.c_str(), "rb");
   fseek(pcmtemp, 0x10, SEEK_SET);
   fread(&wvformat, sizeof(unsigned long), 1, pcmtemp);
   fseek(pcmtemp, 2, SEEK_CUR);
   fread(&ChkChannels, sizeof(unsigned char), 1, pcmtemp);
   fseek(pcmtemp, 0x9, SEEK_CUR);
   fread(&PcmBlockSize, sizeof(short), 1, pcmtemp);
   fseek(pcmtemp,0x16, SEEK_CUR);
   fread(&WaveDataSize, sizeof(unsigned long),1, pcmtemp);

   
   /* look for only trespasser specific block alignments that
   need to be be decoded and standard 512/1024 blk alignments */
   if(wvformat==20){
     if(PcmBlockSize==512 || PcmBlockSize==1024 ||PcmBlockSize
     ==1028 || PcmBlockSize==2056){
    Pcm_Decode=1;
     }
     else{
      std::cout<<"Block alignment is not recognized. Wave can""\n"
      "not be decoded.  Press [Enter] to exit ";
      std::cin.get();
      fclose(pcmtemp);
      return 0;
      }
    }
   
    if(Pcm_Decode==1){
    
    int ChanSelect=ChkChannels;
    
    int values1;
    int values2;
    int values3;
    int values4;
    
    /* for block alignments of 2056  { trespasser compatible }
    and is in stereo { we convert it to single channel } */
    if(PcmBlockSize==2056){
        values1=2048; //2048 + 8 byte header
        values2=4094; // -2 for block header
        values3=16328;//size of write buffer
        values4=2047;  //cut buffer to 1/2 size for conversion
        //from stereo to mono -
        }
        
    /* for block alignments of 1028  {trespasser compatible} */
    if(PcmBlockSize==1028){
        values1=1024; //1024 + 4 byte header
        values2=2047; // -1 for block header
        values3=8196; //size of write buffer
        }
        
   /* for block alignments of 512 {known industry standard for  *
      mono (code remains for reference, as decoding .wav isn't  *
      necessary for default windows (ie. media player) players  */
    if(PcmBlockSize==512){
        values1=508; //508 + 4 byte header 
        values2=1015; //-1 for wave header
        values3=4060; //size of our buffer
        }
        
      /*for block alignments of 1024 {known industry standard for *
      ima/dvi adpcm (stereo(we convert to mono (single channel))  */
    if(PcmBlockSize==1024){
        values1=1016; //1016+8 byte header
        values2=2030; //-2 for wave header
        values3=8120; //size of our buffer
        values4=1015;  //cut buffer to 1/2 size for conversion
        }    
        
    /* mono wave - proceed this step */
    if(ChanSelect==1)
    {
        fread(&Pv_Val, sizeof(short), 1, pcmtemp);
        fread(&Si_Val, sizeof(short), 1, pcmtemp);
        
        unsigned char src2[values1];
        int16_t dst2[values2];
        size_t srcSize2 = values3;
        
        pcmFile = fopen(ApndPath.c_str(), "wb");
         
        fwrite("RIFF", sizeof(char), 4, pcmFile);
        fwrite(&noHeader, sizeof(unsigned long), 1, pcmFile);
        fwrite("WAVEfmt ", sizeof(char), 8, pcmFile);
        
        unsigned long Temp_at_Value = 16;
        unsigned char AlwaysatZeros = 0;
        unsigned char StockChannels = 1;
        unsigned char AlwaysatValue = 0x1;
        
        fwrite(&Temp_at_Value, sizeof(unsigned long), 1, pcmFile);
        fwrite(&AlwaysatValue, sizeof(unsigned char), 1, pcmFile);
        fwrite(&AlwaysatZeros, sizeof(unsigned char), 1, pcmFile);
        fwrite(&StockChannels, sizeof(unsigned char), 1, pcmFile);
        fwrite(&AlwaysatZeros, sizeof(unsigned char), 1, pcmFile);
        
        fwrite(&rawPcm,  sizeof(unsigned char), 16, pcmFile);

        fwrite(&WtHeader, sizeof(unsigned long), 1, pcmFile);
        fwrite(&Pv_Val, sizeof(short), 1, pcmFile);
        
    while(fread(&src2, sizeof(unsigned char), values1, pcmtemp))
         {
         DeCom.Decode(dst2, src2, 0, srcSize2);
         fwrite(&dst2, sizeof(dst2), 1, pcmFile);
         fread(&Pv_Val, sizeof(short), 1, pcmtemp);
         fread(&Si_Val, sizeof(short), 1, pcmtemp);
         fwrite(&Pv_Val, sizeof(short), 1, pcmFile);
       }
  fclose(pcmFile);
  fclose(pcmtemp);
  
  
  //Don't mix c & c++.  Bull. I do it all the time. Since my cal-
  //culations for decompressed file_size was sometimes off by two
  //or more bytes, checking file_size after decoding then writing
  //in those values provides needed, accurate values -
  fstream numbs(ApndPath.c_str(), ios::in | ios::out |ios::bin);
        numbs.seekg( 0, ios::end );
        long numsize = numbs.tellg();
        numbs.seekg( 4, ios::beg );
        
        long minusfileid = numsize-8;
        long minusheader = minusfileid-36;
        
   numbs.write((long *)(&minusfileid), sizeof(minusfileid));
   numbs.seekg( 0x20, ios::cur ); 
   numbs.write((long *)(&minusheader), sizeof(minusheader));
   numbs.close();           
    }
    
    /* Trespasser & standard 1024 block stereo */
    if(ChanSelect==2)
    {
      fread(&st_Pv_Val, sizeof(short), 1, pcmtemp);
      fread(&st_Si_Val, sizeof(short), 1, pcmtemp);
      fread(&st_Pv2_Val, sizeof(short), 1, pcmtemp);
      fread(&st_Si2_Val, sizeof(short), 1, pcmtemp); 
    
      unsigned long st_noHeader, st_WtHeader; 
      unsigned char st_src2[values1];
      int16_t st_dst2[values2];
      int16_t st_dso1[values4];
      size_t st_srcSize2 = values3;
  
        pcmFile = fopen(ApndPath.c_str(), "wb");
         
        fwrite("RIFF", sizeof(char), 4, pcmFile);
        fwrite(&st_noHeader, sizeof(unsigned long), 1, pcmFile);
        fwrite("WAVEfmt ", sizeof(char), 8, pcmFile);
        
        unsigned long st_Temp_at_Value = 16;
        unsigned char st_AlwaysatZeros = 0;
        unsigned char st_StockChannels = 1;
        unsigned char st_AlwaysatValue = 0x1;
        
        fwrite(&st_Temp_at_Value, sizeof(unsigned long), 1, pcmFile);
        fwrite(&st_AlwaysatValue, sizeof(unsigned char), 1, pcmFile);
        fwrite(&st_AlwaysatZeros, sizeof(unsigned char), 1, pcmFile);
        fwrite(&st_StockChannels, sizeof(unsigned char), 1, pcmFile);
        fwrite(&st_AlwaysatZeros, sizeof(unsigned char), 1, pcmFile);
  
        fwrite(&rawPcm,  sizeof(unsigned char), 16, pcmFile);
        fwrite(&st_WtHeader, sizeof(unsigned long), 1, pcmFile);
        fwrite(&st_Pv_Val, sizeof(short), 1, pcmFile);
        
   
   while(fread(&st_src2, sizeof(char), values1, pcmtemp))
        {
         DeCom.Stereo(st_dst2, st_src2, 0, st_srcSize2);
         
         fwrite(&st_dst2, sizeof(st_dso1), 1, pcmFile);
         fread(&st_Pv_Val, sizeof(short), 1, pcmtemp);
         fread(&st_Si_Val, sizeof(short), 1, pcmtemp);
         fread(&st_Pv2_Val, sizeof(short), 1, pcmtemp);
         fread(&st_Si2_Val, sizeof(short), 1, pcmtemp);
         fwrite(&st_Pv_Val, sizeof(short), 1, pcmFile);
       }
       
  fclose(pcmFile);
  fclose(pcmtemp);
  
  //Don't mix c & c++.  Bull. I do it all the time. Since my cal-
  //culations for decompressed file_size was sometimes off by two
  //or more bytes, checking file_size after decoding then writing
  //in those values provides needed, accurate values -
  fstream to_mono(ApndPath.c_str(), ios::in | ios::out |ios::bin);
        to_mono.seekg( 0, ios::end );
        long st_numsize = to_mono.tellg();
        to_mono.seekg( 4, ios::beg );
        
        long st_minusfileid = st_numsize-8;
        long st_minusheader = st_minusfileid-36;
        
   to_mono.write((long *)(&st_minusfileid), sizeof(st_minusfileid));
   to_mono.seekg( 0x20, ios::cur ); 
   to_mono.write((long *)(&st_minusheader), sizeof(st_minusheader));
   to_mono.close();
   }
     } 
     
      if(Pcm_Decode==0){
        std::cout<<"Wav format could not be indentified as an ima/dvi""\n"
        "adpcm wave. Press [Enter] to exit ";
        std::cin.get();
        fclose(pcmtemp);
       } 
       
  return 0;
}
